//////////////////////////////////////////////////////////////////////
// ParallelPro.cpp: implementation of the CParallelPro class.
//ฺԲ߽пƣ"Isp̷"
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "EPro.h"
#include "Pro.h"
#include "ParallelPro.h"
#include "IsPro.h"
#include "At89s51Isp.h"//AT89S51Isp̷


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CParallelPro::CParallelPro()
{
	//еIsp̷뵽
	m_arIsp.Add(new CAt89s51Isp);

}

CParallelPro::~CParallelPro()
{

}

extern CString m_strAppPath;//Ӧóڵ·

BOOL CParallelPro::InitPort(CPro* pPro,int nPort,int nProType,int nIspSpd)
{	//ʼں
	TRACE("CParallelPro::InitPort,ProType:%d,nIspSpd:%d\n",nProType,nIspSpd);
	TRACE("Current Isp:%d\n",m_arIsp.GetSize());
	m_pPro=pPro;
	m_nProType=nProType;
	m_nIspSpd=nIspSpd;
	if(m_bPort=CParallelPort::InitPort())//ʼ
		pPro->Notify(PRO_INIT_PARALLEL_SEC);
	else
		pPro->Notify(PRO_INIT_PARALLEL_ER);
	m_bThread=FALSE;
	if(nProType==1)//Easy Isp
	{
		CString strEasyIspIni;
		strEasyIspIni=m_strAppPath+"EasyIsp.ini";
		//EasyIsp.iniļϢ
		//"EasyIsp.ini"ļʹĬϵ(ϰ汾)
		m_nPinMosi=GetPrivateProfileInt("ſ","MOSI",14,strEasyIspIni);
		m_nPinMiso=GetPrivateProfileInt("ſ","MISO",15,strEasyIspIni);
		m_nPinSck=GetPrivateProfileInt("ſ","SCK",1,strEasyIspIni);
		m_nPinRst=GetPrivateProfileInt("ſ","RST",16,strEasyIspIni);
		m_nPinLe=GetPrivateProfileInt("ſ","LE",17,strEasyIspIni);
		m_nPinOe=GetPrivateProfileInt("ſ","OE",2,strEasyIspIni);
		m_nPinR1=GetPrivateProfileInt("ſ","R1",3,strEasyIspIni);
		m_nPinR2=GetPrivateProfileInt("ſ","R2",4,strEasyIspIni);
		m_bLe=GetPrivateProfileInt("(LE)","Enable",1,strEasyIspIni);
		m_b2Le=GetPrivateProfileInt("(LE)","Disable",0,strEasyIspIni);
		m_bOe=GetPrivateProfileInt("(OE)","Enable",0,strEasyIspIni);
		m_b2Oe=GetPrivateProfileInt("(OE)","Disable",1,strEasyIspIni);
		
	}
	else if(nProType==2)//Atmel ByteBlaster
	{
		m_nPinRst=PIN_SELIN;//PIN_SELINParallelPort˶
		m_nPinMosi=PIN_D0;
		m_nPinMiso=PIN_ACK;
		m_nPinSck=PIN_STROBE;
		m_nPinLe=PIN_D2;//le,Ϊʱٶһõ
		m_bLe=0;
		m_b2Le=0;
		m_nPinOe=0;//oe
		m_nPinR1=m_nPinAf=PIN_AUTO;//
		m_nPinR2=m_nPinIni=PIN_INIT;//

	}
	else if(nProType==3)//Altera ByteBlaster
	{
		m_nPinRst=3;
		m_nPinMosi=8;
		m_nPinMiso=11;
		m_nPinSck=2;
		m_nPinLe=14;//74244le
		m_bLe=0;
		m_b2Le=0;//leõ͵ƽ
		m_nPinOe=0;//ûOe
		m_nPinR1=0;//
		m_nPinR2=0;//ޱ
	}
	SetPinLogic(m_nPinLe,m_bLe);

	for(int n=0;n<m_arIsp.GetSize();n++)//ʼÿ"Isp̷"
		m_arIsp.GetAt(n)->InitIsPro(this);
	return m_bPort;
}

CIsPro* CParallelPro::GetIsPro(BYTE FID)
{	//ָ֧FID"Isp̷"
	for(int n=0;n<m_arIsp.GetSize();n++)
		if(m_arIsp.GetAt(n)->FID==FID)
			return m_pIsPro=m_arIsp.GetAt(n);
			//õǰ"Isp̷"ָ
	return NULL;
}

void CParallelPro::DetectPro(int FID)
{
	if(m_bPort)
		if(GetIsPro(FID)!=NULL)//ѯǷָ֧FID
		{
			m_pPro->Notify(PRO_AVAILABLE);//ѯɹ֪ͨ""
			return;
		}
	m_pPro->Notify(PRO_INVALID);//ѯʧ
}

void CParallelPro::ReadSign(BYTE FID)//
{
	if(m_bThread)//һβ̻߳û
	{
		m_pPro->Notify(PRO_INVALID);
		return;
	}
	if(GetIsPro(FID)==NULL)//ѯǷָ֧FID
	{
		m_pPro->Notify(PRO_WORK_INVALID);
		return;
	}
	m_nCurWork=1;//ǰʶ
	AfxBeginThread(ProWorkThread,this);
}

void CParallelPro::Erase(BYTE FID)
{
	if(m_bThread)//һβ̻߳û
	{
		m_pPro->Notify(PRO_INVALID);
		return;
	}
	if(GetIsPro(FID)==NULL)//ѯǷָ֧FID
	{
		m_pPro->Notify(PRO_WORK_INVALID);
		return;
	}
	m_nCurWork=2;//ǰʶ
	AfxBeginThread(ProWorkThread,this);
}

void CParallelPro::BeginWrite(BYTE FID)
{
	if(m_bThread)//һβ̻߳û
	{
		m_pPro->Notify(PRO_INVALID);
		return;
	}
	if(GetIsPro(FID)==NULL)//ѯǷָ֧FID
	{
		m_pPro->Notify(PRO_WORK_INVALID);
		return;
	}
	m_nCurWork=3;//ǰʶ
	AfxBeginThread(ProWorkThread,this);
}

void CParallelPro::BeginRead(BYTE FID)
{
	if(m_bThread)//һβ̻߳û
	{
		m_pPro->Notify(PRO_INVALID);
		return;
	}
	if(GetIsPro(FID)==NULL)//ѯǷָ֧FID
	{
		m_pPro->Notify(PRO_WORK_INVALID);
		return;
	}
	m_nCurWork=4;//ǰʶ
	AfxBeginThread(ProWorkThread,this);
}

void CParallelPro::LockBit(BYTE FID,int nBit)
{
	if(m_bThread)//һβ̻߳û
	{
		m_pPro->Notify(PRO_INVALID);
		return;
	}
	if(GetIsPro(FID)==NULL)//ѯǷָ֧FID
	{
		m_pPro->Notify(PRO_WORK_INVALID);
		return;
	}
	m_nLockBits=nBit;
	m_nCurWork=5;//ǰʶ
	AfxBeginThread(ProWorkThread,this);
}

UINT CParallelPro::ProWorkThread(LPVOID pParam)
{	//()߳
	CParallelPro* pParlPro=(CParallelPro*)pParam;
	CPro* pPro=pParlPro->m_pPro;
	CIsPro* pIsPro=pParlPro->m_pIsPro;
	pParlPro->m_bThread=TRUE;
	TRACE("m_nCurWork:%d\n",pParlPro->m_nCurWork);
	pParlPro->SetPinLogic(pParlPro->m_nPinOe,pParlPro->m_bOe);
	//״̬
	pIsPro->PreparePro();//ǰ׼
	switch(pParlPro->m_nCurWork)//ݵǰʶú
	{
	case 1://
		pIsPro->ReadSign(pPro->SignByte);
		//"Isp̷"еı̷
		pIsPro->ProOver();//̽Ĺ
		pParlPro->m_bThread=FALSE;
		pPro->CheckChip();
		break;
	case 2://
		pIsPro->Erase();
		//"Isp̷"еı̷
		pIsPro->ProOver();//̽Ĺ
		pParlPro->m_bThread=FALSE;
		pPro->Notify(PRO_ERASE);
		break;
	case 3://д
		pPro->m_nDataLength=pPro->GetMinLength(pPro->m_pWriteBuf,0x10000);
		pIsPro->PreparePro();
		for(pPro->m_nAddr=0;pPro->m_nAddr<pPro->m_nDataLength;pPro->m_nAddr++)
		{
			if(!pIsPro->Write(pPro->m_pWriteBuf[pPro->m_nAddr],pPro->m_nAddr))
			{//"Isp̷"еı̷
				pIsPro->ProOver();//̽Ĺ
				pPro->Notify(PRO_WRITE_ER);
				pParlPro->m_bThread=FALSE;
				return -1;
			}
			if(pPro->m_nAddr%0x0f==0)
				pPro->Notify(PRO_WRITE_BLOCK);
		}
		pIsPro->ProOver();
		pParlPro->m_bThread=FALSE;
		pPro->Notify(PRO_WRITE_OVER);
		break;
	case 4://
		if(!pPro->m_bCheck)
			pPro->m_nDataLength=pPro->GetCurChip()->RomSize*1024;
		if(pPro->m_nDataLength==0)
		{
			pPro->Notify(PRO_READ_OVER);
			TRACE("ReadRomThread(...) Over\n");
			break;
		}
		for(pPro->m_nAddr=0;pPro->m_nAddr<pPro->m_nDataLength;pPro->m_nAddr++)
		{
			pPro->m_pReadBuf[pPro->m_nAddr]=pIsPro->Read(pPro->m_nAddr);
			//"Isp̷"еı̷
			if(pPro->m_nAddr%0x0f==0)
				pPro->Notify(PRO_READ_BLOCK);
		}
		pIsPro->ProOver();//̽Ĺ
		pParlPro->m_bThread=FALSE;
		pPro->Notify(PRO_READ_OVER);
		break;
	case 5://дλ
		pIsPro->LockBit(pParlPro->m_nLockBits);
		//"Isp̷"еı̷
		pIsPro->ProOver();//̽Ĺ
		pParlPro->m_bThread=FALSE;
		pPro->Notify(PRO_LOCK_BIT);
		break;
	default:
		pParlPro->m_bThread=FALSE;
		break;
	}
	//̽
	pParlPro->SetPinLogic(pParlPro->m_nPinOe,pParlPro->m_b2Oe);
	//״̬
	return 0;
}


BOOL CParallelPro::GetMiso()//õMISOŵĵƽ
{
	if(m_nIspSpd==2)
	{
		return GetPinLogic(m_nPinMiso);
	}
	else if(m_nIspSpd==1)
	{
		SetPinLogic(m_nPinLe,m_bLe);//
		return GetPinLogic(m_nPinMiso);
	}
	else
	{
		SetPinLogic(m_nPinLe,m_bLe);//
		for(int n=0;n<=1000;n++)//ʱ
		{
		}
		SetPinLogic(m_nPinLe,m_b2Le);//ر
		return GetPinLogic(m_nPinMiso);
	}
}

void CParallelPro::SetMosi(BOOL bLogic)
{
		
	if(bLogic)
		SetPinH(m_nPinMosi);
	else
		SetPinL(m_nPinMosi);
	if(m_nIspSpd==2)
	{
		return;
	}
	else if(m_nIspSpd==1)
	{
		SetPinLogic(m_nPinLe,m_bLe);//
		return;
	}
	else
	{
		SetPinLogic(m_nPinLe,m_bLe);//
		for(int n=0;n<=1000;n++)//ʱ
		{
		}
		SetPinLogic(m_nPinLe,m_b2Le);//ر
	}
}

void CParallelPro::SetRst(BOOL bLogic)
{
	
	if(bLogic)
		SetPinH(m_nPinRst);
	else
		SetPinL(m_nPinRst);
	if(m_nIspSpd==2)
	{
		return;
	}
	else if(m_nIspSpd==1)
	{
		SetPinLogic(m_nPinLe,m_bLe);//
		return;
	}
	else
	{
		SetPinLogic(m_nPinLe,m_bLe);//
		for(int n=0;n<=1000;n++)//ʱ
		{
		}
		SetPinLogic(m_nPinLe,m_b2Le);//ر
	}
}

void CParallelPro::SetSck(BOOL bLogic)
{
	if(bLogic)
		SetPinH(m_nPinSck);
	else
		SetPinL(m_nPinSck);
	if(m_nIspSpd==2)
	{
		return;
	}
	else if(m_nIspSpd==1)
	{
		SetPinLogic(m_nPinLe,m_bLe);//
		return;
	}
	else
	{
		SetPinLogic(m_nPinLe,m_bLe);//
		for(int n=0;n<=1000;n++)//ʱ
		{
		}
		SetPinLogic(m_nPinLe,m_b2Le);//ر
	}
}


void CParallelPro::SckBytes(int nBytes)//ͨͨ
{
	for(int n=0;n<nBytes;n++)
	{	
		SetSck(0);
		SetMosi((OutBuf[n] & 0x80));//SCKΪ͵ƽʱһλ
		SetSck(1);
		if(GetMiso())//SCKΪƽʱһλ
		{
		
			InBuf[n]=InBuf[n] | 0x80;
		}
		else
		{	
			InBuf[n]=InBuf[n] & 0x7f;
		}
		SetSck(0);
		SetMosi((OutBuf[n] & 0x40));
		SetSck(1);
		if(GetMiso())
		{
		
			InBuf[n]=InBuf[n] | 0x40;
		}
		else
		{	
			InBuf[n]=InBuf[n] & 0xbf;
		}
		SetSck(0);

		SetMosi((OutBuf[n] & 0x20));
		SetSck(1);
		if(GetMiso())
		{
		
			InBuf[n]=InBuf[n] | 0x20;
		}
		else
		{	
			InBuf[n]=InBuf[n] & 0xdf;
		}
		SetSck(0);

		SetMosi((OutBuf[n] & 0x10));
		SetSck(1);
		if(GetMiso())
		{
		
			InBuf[n]=InBuf[n] | 0x10;
		}
		else
		{	
			InBuf[n]=InBuf[n] & 0xef;
		}
		SetSck(0);

		SetMosi((OutBuf[n] & 0x08));
		SetSck(1);
		if(GetMiso())
		{
		
			InBuf[n]=InBuf[n] | 0x08;
		}
		else
		{	
			InBuf[n]=InBuf[n] & 0xf7;
		}
		SetSck(0);

		SetMosi((OutBuf[n] & 0x04));
		SetSck(1);
		if(GetMiso())
		{
		
			InBuf[n]=InBuf[n] | 0x04;
		}
		else
		{	
			InBuf[n]=InBuf[n] & 0xfb;
		}
		SetSck(0);

		SetMosi((OutBuf[n] & 0x02));
		SetSck(1);
		if(GetMiso())
		{
		
			InBuf[n]=InBuf[n] | 0x02;
		}
		else
		{	
			InBuf[n]=InBuf[n] & 0xfd;
		}
		SetSck(0);

		SetMosi((OutBuf[n] & 0x01));
		SetSck(1);
		if(GetMiso())
		{
		
			InBuf[n]=InBuf[n] | 0x01;
		}
		else
		{	
			InBuf[n]=InBuf[n] & 0xfe;
		}
		SetSck(0);
	}
}




